<?php

/**
 * Try and import any CCK fields into the node in the format expected
 * 
 * @TODO this is probably broken in the upgrade. Revisit.
 * Need to re-aquire the DOM element, nnot just the text string maybe. Maybe
 * should ignore the previous text scan import altogether.
 */
function content_import_html($profile, &$node, $datadoc = NULL) {

  if (function_exists('content_types') && ($content_def = content_types($node->type)) /*&& $datadoc*/ && ! empty($content_def['fields'])) {
    if (! $node->body) $node->body = "PLACEHOLDER. CCK needs no body";
  }
  else {
    debug("No CCK fields to scan for", 2);
    return; // no valid CCK stuff for me to work on
  }
  debug("Scanning import document for CCK fields to import into this $node->type", 2);
  
  // Look for ids or classes in the doc matching an expected CCK field name
  foreach ($content_def['fields'] as $field_id => $field_def) {
    $field_short_id = substr($field_id, 6); // allow both fieldname_field and just fieldname.
    
    // Do my own DOM scanning. Better than the default text absorbing that just happened before.
    // match any of id='fieldname', class='fieldname', id='fieldname_field', class='fieldname_field',   
    // Construct an xpath (could have been just a string, I know)
    $match_patterns = array();
    foreach (array('id', 'class') as $attribute_label) {
      foreach (array($field_id, $field_short_id) as $alt_field_id) {
        $match_patterns[] = "@$attribute_label='$alt_field_id'";
      }
    }
    $xpath = ".//*[". join($match_patterns, ' or ') ."]";
#dpm("looking for $xpath in ");
#debug_code(xml_tostring($datadoc));
#debug_code($datadoc);

    $found_elements = xml_query($datadoc, $xpath);
    if(! $found_elements) {
      debug("No value for $field_id field found in the doc");
      continue;
    }

    // Put them all into an array like CCK expects
    if (! is_array($node->{$field_def['field_name']})) {
      $node->{$field_def['field_name']} = array();
    }
    foreach($found_elements as $found_element) {
      // Absorbing data blobs
      // We grab the CONTENT of the named div, normally not including the wrapper.
      // Its the difference between xml_tostring and xml_textcontent
      debug("Found an <b>expected</b> CCK field - '$field_id' , Absorbing it into the right place in the right way", 1);
      // TODO move this logic into a switch($field_def['type']) ?
      if ($field_def['text_processing']) {
        $field = array(
          'value' => xml_tostring($found_element, TRUE), 
          'format' => import_html_get_preferred_filter() 
          );
        }
      else {
        // Can only be plaintext, no formatted HTML
        debug("The field '$field_id' is configured as plaintext only. HTML found in here will be stripped out.",2);
        $field = array(
          'value' => xml_textcontent($found_element), 
        );
      
        /** 
         * Special cases for field types
         * INCOMPLETE
         * TODO clean up a general case for these
         */
        if ($field_def['type'] == 'image') {
          $field = array(
            'filepath' => xml_textcontent($found_element), 
          );
        }
        // ... other special field types? Add here

        // TODO support for other CCK
      } // has special formatting
      
      $node->{$field_def['field_name']}[] = $field; 
    }
  }
}

